/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arrays_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t84 = nm->mkBoundVar("t84", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i85 = nm->mkBoundVar("i85", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e86 = nm->mkBoundVar("e86", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t87 = nm->mkBoundVar("t87", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i88 = nm->mkBoundVar("i88", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j89 = nm->mkBoundVar("j89", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e90 = nm->mkBoundVar("e90", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t91 = nm->mkBoundVar("t91", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i92 = nm->mkBoundVar("i92", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e93 = nm->mkBoundVar("e93", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node f94 = nm->mkBoundVar("f94", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t95 = nm->mkBoundVar("t95", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i96 = nm->mkBoundVar("i96", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e97 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-arrays-rewrites.cpp
            db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE, { t84, i85, e86 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t84,i85,e86 }),i85 }), e86, e97, Node::null());
db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE2, { t87, i88, j89, e90 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t87,i88,e90 }),j89 }), nm->mkNode(Kind::SELECT, { t87,j89 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { i88,j89 }) }), Node::null());
db.addRule(ProofRewriteRule::ARRAY_STORE_OVERWRITE, { t91, i92, e93, f94 }, nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t91,i92,e93 }),i92,f94 }), nm->mkNode(Kind::STORE, { t91,i92,f94 }), e97, Node::null());
db.addRule(ProofRewriteRule::ARRAY_STORE_SELF, { t95, i96 }, nm->mkNode(Kind::STORE, { t95,i96,nm->mkNode(Kind::SELECT, { t95,i96 }) }), t95, e97, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
