/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_elimination(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x432 = nm->mkBoundVar("x432", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y433 = nm->mkBoundVar("y433", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x434 = nm->mkBoundVar("x434", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y435 = nm->mkBoundVar("y435", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x436 = nm->mkBoundVar("x436", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y437 = nm->mkBoundVar("y437", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x438 = nm->mkBoundVar("x438", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y439 = nm->mkBoundVar("y439", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x440 = nm->mkBoundVar("x440", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y441 = nm->mkBoundVar("y441", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x442 = nm->mkBoundVar("x442", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y443 = nm->mkBoundVar("y443", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x444 = nm->mkBoundVar("x444", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x445 = nm->mkBoundVar("x445", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x446 = nm->mkBoundVar("x446", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y447 = nm->mkBoundVar("y447", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x448 = nm->mkBoundVar("x448", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y449 = nm->mkBoundVar("y449", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x450 = nm->mkBoundVar("x450", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n451 = nm->mkBoundVar("n451", nm->integerType());
Node x452 = nm->mkBoundVar("x452", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n453 = nm->mkBoundVar("n453", nm->integerType());
Node x454 = nm->mkBoundVar("x454", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount455 = nm->mkBoundVar("amount455", nm->integerType());
Node x456 = nm->mkBoundVar("x456", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount457 = nm->mkBoundVar("amount457", nm->integerType());
Node x458 = nm->mkBoundVar("x458", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount459 = nm->mkBoundVar("amount459", nm->integerType());
Node x460 = nm->mkBoundVar("x460", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount461 = nm->mkBoundVar("amount461", nm->integerType());
Node x462 = nm->mkBoundVar("x462", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y463 = nm->mkBoundVar("y463", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x464 = nm->mkBoundVar("x464", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y465 = nm->mkBoundVar("y465", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x466 = nm->mkBoundVar("x466", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y467 = nm->mkBoundVar("y467", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x468 = nm->mkBoundVar("x468", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y469 = nm->mkBoundVar("y469", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x470 = nm->mkBoundVar("x470", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y471 = nm->mkBoundVar("y471", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x472 = nm->mkBoundVar("x472", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n473 = nm->mkBoundVar("n473", nm->integerType());
Node x474 = nm->mkBoundVar("x474", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n475 = nm->mkBoundVar("n475", nm->integerType());
Node x476 = nm->mkBoundVar("x476", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y477 = nm->mkBoundVar("y477", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x478 = nm->mkBoundVar("x478", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y479 = nm->mkBoundVar("y479", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x480 = nm->mkBoundVar("x480", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y481 = nm->mkBoundVar("y481", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x482 = nm->mkBoundVar("x482", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y483 = nm->mkBoundVar("y483", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x484 = nm->mkBoundVar("x484", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y485 = nm->mkBoundVar("y485", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x486 = nm->mkBoundVar("x486", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y487 = nm->mkBoundVar("y487", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x488 = nm->mkBoundVar("x488", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y489 = nm->mkBoundVar("y489", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x490 = nm->mkBoundVar("x490", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y491 = nm->mkBoundVar("y491", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x492 = nm->mkBoundVar("x492", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y493 = nm->mkBoundVar("y493", nm->mkAbstractType(Kind::BITVECTOR_TYPE));

  // Definitions
Node e494 = nm->mkConstRealOrInt(Rational(1));
Node e495 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) });
Node e496 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) });
Node e497 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::BITVECTOR_SUB, { x492,y493 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e498 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),y493 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e499 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x492 }),nm->mkConstRealOrInt(Rational(1)) }),x492 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e500 = nm->mkNode(Kind::BITVECTOR_SIZE, { x490 });
Node e501 = nm->mkConst(true);
Node e502 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x488 }),nm->mkConstRealOrInt(Rational(1)) }) }) });
Node e503 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x488,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x488 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x488 }),x488 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y489,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x488 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y489 }),y489 }) });
Node e504 = nm->mkNode(Kind::BITVECTOR_UGE, { x488,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x488 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) });
Node e505 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) });
Node e506 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),x486 }),nm->mkNode(Kind::BITVECTOR_NEG, { x486 }),x486 }),nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),y487 }),nm->mkNode(Kind::BITVECTOR_NEG, { y487 }),y487 }) });
Node e507 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x486 }),nm->mkConstRealOrInt(Rational(1)) }),x486 });
Node e508 = nm->mkConstRealOrInt(Rational(0));
Node e509 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) });
Node e510 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x484,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x484 }),x484 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y485,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y485 }),y485 }) });
Node e511 = nm->mkNode(Kind::BITVECTOR_UGE, { y485,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) });
Node e512 = nm->mkNode(Kind::BITVECTOR_UGE, { x484,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) });
Node e513 = nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x484,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x484 }),x484 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y485,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y485 }),y485 }) }) });
Node e514 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_UGE, { y485,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }) });
Node e515 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_UGE, { x484,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x484 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }) });
Node e516 = nm->mkNode(Kind::BITVECTOR_SIZE, { x484 });
Node e517 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) });
Node e518 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),x482 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x482 }),x482 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),y483 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y483 }),y483 }) });
Node e519 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),y483 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e520 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),x482 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e521 = nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),x482 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x482 }),x482 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),y483 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y483 }),y483 }) }) });
Node e522 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),y483 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }) });
Node e523 = nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x482 }),nm->mkConstRealOrInt(Rational(1)) }),x482 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }) });
Node e524 = nm->mkNode(Kind::BITVECTOR_SIZE, { x482 });
Node e525 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) });
Node e526 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::BITVECTOR_ADD, { x478,y479 }) });
Node e527 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkConstRealOrInt(Rational(1)) });
Node e528 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),y479 });
Node e529 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x478 }),nm->mkConstRealOrInt(Rational(1)) }),x478 });
Node e530 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x476 }),nm->mkConstRealOrInt(Rational(1)) });
Node e531 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x474 }),nm->mkConstRealOrInt(Rational(1)) });
Node e532 = nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),nm->mkConstRealOrInt(Rational(1)) }) }) });
Node e533 = nm->mkNode(Kind::BITVECTOR_UDIV, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { x470,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x470 }),x470 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::BITVECTOR_UGE, { y471,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y471 }),y471 }) });
Node e534 = nm->mkNode(Kind::BITVECTOR_UGE, { y471,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) });
Node e535 = nm->mkNode(Kind::BITVECTOR_UGE, { x470,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),nm->mkConstRealOrInt(Rational(1)) }) }) }) });
Node e536 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) });
Node e537 = nm->mkNode(Kind::BITVECTOR_UDIV, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),x468 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x468 }),x468 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),y469 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y469 }),y469 }) });
Node e538 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),y469 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e539 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x468 }),nm->mkConstRealOrInt(Rational(1)) }),x468 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) }) });
Node e540 = nm->mkNode(Kind::BITVECTOR_SIZE, { x458 });
Node e541 = nm->mkNode(Kind::INTS_MODULUS, { amount459,nm->mkNode(Kind::BITVECTOR_SIZE, { x458 }) });
Node e542 = nm->mkNode(Kind::BITVECTOR_SIZE, { x454 });
Node e543 = nm->mkNode(Kind::INTS_MODULUS, { amount455,nm->mkNode(Kind::BITVECTOR_SIZE, { x454 }) });
Node e544 = nm->mkNode(Kind::BITVECTOR_SIZE, { x440 });
Node e545 = nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkNode(Kind::BITVECTOR_SIZE, { x440 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x440 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::BITVECTOR_SIZE, { x440 }) }) });

  // Rules

        {
            // from rewrites-bv-rewrites-elimination.cpp
            db.addRule(ProofRewriteRule::BV_UGT_ELIMINATE, { x432, y433 }, nm->mkNode(Kind::BITVECTOR_UGT, { x432,y433 }), nm->mkNode(Kind::BITVECTOR_ULT, { y433,x432 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_UGE_ELIMINATE, { x434, y435 }, nm->mkNode(Kind::BITVECTOR_UGE, { x434,y435 }), nm->mkNode(Kind::BITVECTOR_ULE, { y435,x434 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SGT_ELIMINATE, { x436, y437 }, nm->mkNode(Kind::BITVECTOR_SGT, { x436,y437 }), nm->mkNode(Kind::BITVECTOR_SLT, { y437,x436 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SGE_ELIMINATE, { x438, y439 }, nm->mkNode(Kind::BITVECTOR_SGE, { x438,y439 }), nm->mkNode(Kind::BITVECTOR_SLE, { y439,x438 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SLT_ELIMINATE, { x440, y441 }, nm->mkNode(Kind::BITVECTOR_SLT, { x440,y441 }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x440,e545 }),nm->mkNode(Kind::BITVECTOR_ADD, { y441,e545 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SLE_ELIMINATE, { x442, y443 }, nm->mkNode(Kind::BITVECTOR_SLE, { x442,y443 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_SLT, { y443,x442 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_REDOR_ELIMINATE, { x444 }, nm->mkNode(Kind::BITVECTOR_REDOR, { x444 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_COMP, { x444,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,nm->mkNode(Kind::BITVECTOR_SIZE, { x444 }) }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_REDAND_ELIMINATE, { x445 }, nm->mkNode(Kind::BITVECTOR_REDAND, { x445 }), nm->mkNode(Kind::BITVECTOR_COMP, { x445,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,nm->mkNode(Kind::BITVECTOR_SIZE, { x445 }) }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_ELIMINATE, { x446, y447 }, nm->mkNode(Kind::BITVECTOR_ULE, { x446,y447 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { y447,x446 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_COMP_ELIMINATE, { x448, y449 }, nm->mkNode(Kind::BITVECTOR_COMP, { x448,y449 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x448,y449 }),e496,e527 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_REPEAT_ELIMINATE_1, { x450, n451 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),n451,x450 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { x450,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),nm->mkNode(Kind::SUB, { n451,e494 }),x450 }) }), nm->mkNode(Kind::GT, { n451,e494 }), Node::null());
db.addRule(ProofRewriteRule::BV_REPEAT_ELIMINATE_2, { x452, n453 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),n453,x452 }), x452, nm->mkNode(Kind::EQUAL, { n453,e494 }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_1, { x454, amount455 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount455,x454 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e542,nm->mkNode(Kind::ADD, { e494,e543 }) }),e508,x454 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e542,e494 }),nm->mkNode(Kind::SUB, { e542,e543 }),x454 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e543,e508 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_2, { x456, amount457 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount457,x456 }), x456, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount457,nm->mkNode(Kind::BITVECTOR_SIZE, { x456 }) }),e508 }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_1, { x458, amount459 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount459,x458 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e541,e494 }),e508,x458 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e540,e494 }),e541,x458 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e541,e508 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_2, { x460, amount461 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount461,x460 }), x460, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount461,nm->mkNode(Kind::BITVECTOR_SIZE, { x460 }) }),e508 }), Node::null());
db.addRule(ProofRewriteRule::BV_NAND_ELIMINATE, { x462, y463 }, nm->mkNode(Kind::BITVECTOR_NAND, { x462,y463 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_AND, { x462,y463 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_NOR_ELIMINATE, { x464, y465 }, nm->mkNode(Kind::BITVECTOR_NOR, { x464,y465 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_OR, { x464,y465 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_XNOR_ELIMINATE, { x466, y467 }, nm->mkNode(Kind::BITVECTOR_XNOR, { x466,y467 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x466,y467 }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SDIV_ELIMINATE, { x468, y469 }, nm->mkNode(Kind::BITVECTOR_SDIV, { x468,y469 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::XOR, { e539,e538 }),nm->mkNode(Kind::BITVECTOR_NEG, { e537 }),e537 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SDIV_ELIMINATE_FEWER_BITWISE_OPS, { x470, y471 }, nm->mkNode(Kind::BITVECTOR_SDIV, { x470,y471 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::XOR, { e535,e534 }),nm->mkNode(Kind::BITVECTOR_NEG, { e533 }),e533 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE, { x472, n473 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n473,x472 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,n473 }),x472 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ELIMINATE, { x474, n475 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n475,x474 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),n475,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e531,e531,x474 }) }),x474 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_UADDO_ELIMINATE, { x476, y477 }, nm->mkNode(Kind::BITVECTOR_UADDO, { x476,y477 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e530,e530,nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_CONCAT, { e527,x476 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { e527,y477 }) }) }),e496 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SADDO_ELIMINATE, { x478, y479 }, nm->mkNode(Kind::BITVECTOR_SADDO, { x478,y479 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e529,e527 }),nm->mkNode(Kind::EQUAL, { e528,e527 }) }),nm->mkNode(Kind::EQUAL, { e526,e496 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e529,e496 }),nm->mkNode(Kind::EQUAL, { e528,e496 }) }),nm->mkNode(Kind::EQUAL, { e526,e527 }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SDIVO_ELIMINATE, { x480, y481 }, nm->mkNode(Kind::BITVECTOR_SDIVO, { x480,y481 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x480,nm->mkNode(Kind::BITVECTOR_CONCAT, { e496,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x480 }),e494 }) }) }) }),nm->mkNode(Kind::EQUAL, { y481,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,nm->mkNode(Kind::BITVECTOR_SIZE, { y481 }) }) }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SMOD_ELIMINATE, { x482, y483 }, nm->mkNode(Kind::BITVECTOR_SMOD, { x482,y483 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { e518,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,e524 }) }),e518,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e523,e522 }),e518,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e520,e522 }),nm->mkNode(Kind::BITVECTOR_ADD, { e521,y483 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e523,e519 }),nm->mkNode(Kind::BITVECTOR_ADD, { e518,y483 }),e521 }) }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SMOD_ELIMINATE_FEWER_BITWISE_OPS, { x484, y485 }, nm->mkNode(Kind::BITVECTOR_SMOD, { x484,y485 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { e510,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e508,e516 }) }),e510,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e515,e514 }),e510,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e512,e514 }),nm->mkNode(Kind::BITVECTOR_ADD, { e513,y485 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e515,e511 }),nm->mkNode(Kind::BITVECTOR_ADD, { e510,y485 }),e513 }) }) }) }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SREM_ELIMINATE, { x486, y487 }, nm->mkNode(Kind::BITVECTOR_SREM, { x486,y487 }), nm->mkNode(Kind::BITVECTOR_ITE, { e507,nm->mkNode(Kind::BITVECTOR_NEG, { e506 }),e506 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SREM_ELIMINATE_FEWER_BITWISE_OPS, { x488, y489 }, nm->mkNode(Kind::BITVECTOR_SREM, { x488,y489 }), nm->mkNode(Kind::ITE, { e504,nm->mkNode(Kind::BITVECTOR_NEG, { e503 }),e503 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_USUBO_ELIMINATE, { x490, y491 }, nm->mkNode(Kind::BITVECTOR_USUBO, { x490,y491 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e500,e500,nm->mkNode(Kind::BITVECTOR_SUB, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e494,x490 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e494,y491 }) }) }),e496 }), e501, Node::null());
db.addRule(ProofRewriteRule::BV_SSUBO_ELIMINATE, { x492, y493 }, nm->mkNode(Kind::BITVECTOR_SSUBO, { x492,y493 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { e499,nm->mkNode(Kind::NOT, { e498 }),nm->mkNode(Kind::NOT, { e497 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { e499 }),e498,e497 }) }), e501, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
