/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_simplification(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node c546 = nm->mkBoundVar("c546", nm->mkBitVectorType(1));
Node x547 = nm->mkBoundVar("x547", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c548 = nm->mkBoundVar("c548", nm->mkBitVectorType(1));
Node c549 = nm->mkBoundVar("c549", nm->mkBitVectorType(1));
Node c0550 = nm->mkBoundVar("c0550", nm->mkBitVectorType(1));
Node t0551 = nm->mkBoundVar("t0551", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0552 = nm->mkBoundVar("e0552", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1553 = nm->mkBoundVar("e1553", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0554 = nm->mkBoundVar("c0554", nm->mkBitVectorType(1));
Node t0555 = nm->mkBoundVar("t0555", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1556 = nm->mkBoundVar("t1556", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1557 = nm->mkBoundVar("e1557", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0558 = nm->mkBoundVar("c0558", nm->mkBitVectorType(1));
Node t0559 = nm->mkBoundVar("t0559", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0560 = nm->mkBoundVar("e0560", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1561 = nm->mkBoundVar("t1561", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1562 = nm->mkBoundVar("e1562", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0563 = nm->mkBoundVar("c0563", nm->mkBitVectorType(1));
Node c1564 = nm->mkBoundVar("c1564", nm->mkBitVectorType(1));
Node t1565 = nm->mkBoundVar("t1565", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1566 = nm->mkBoundVar("e1566", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0567 = nm->mkBoundVar("c0567", nm->mkBitVectorType(1));
Node c1568 = nm->mkBoundVar("c1568", nm->mkBitVectorType(1));
Node t1569 = nm->mkBoundVar("t1569", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1570 = nm->mkBoundVar("e1570", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0571 = nm->mkBoundVar("c0571", nm->mkBitVectorType(1));
Node c1572 = nm->mkBoundVar("c1572", nm->mkBitVectorType(1));
Node t0573 = nm->mkBoundVar("t0573", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1574 = nm->mkBoundVar("e1574", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0575 = nm->mkBoundVar("c0575", nm->mkBitVectorType(1));
Node c1576 = nm->mkBoundVar("c1576", nm->mkBitVectorType(1));
Node t1577 = nm->mkBoundVar("t1577", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t0578 = nm->mkBoundVar("t0578", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x579 = nm->mkBoundVar("x579", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz580 = nm->mkBoundVar("sz580", nm->integerType());
Node x581 = nm->mkBoundVar("x581", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount582 = nm->mkBoundVar("amount582", nm->integerType());
Node sz583 = nm->mkBoundVar("sz583", nm->integerType());
Node x584 = nm->mkBoundVar("x584", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount585 = nm->mkBoundVar("amount585", nm->integerType());
Node sz586 = nm->mkBoundVar("sz586", nm->integerType());
Node x587 = nm->mkBoundVar("x587", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz588 = nm->mkBoundVar("sz588", nm->integerType());
Node x589 = nm->mkBoundVar("x589", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount590 = nm->mkBoundVar("amount590", nm->integerType());
Node sz591 = nm->mkBoundVar("sz591", nm->integerType());
Node x592 = nm->mkBoundVar("x592", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount593 = nm->mkBoundVar("amount593", nm->integerType());
Node sz594 = nm->mkBoundVar("sz594", nm->integerType());
Node x595 = nm->mkBoundVar("x595", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz596 = nm->mkBoundVar("sz596", nm->integerType());
Node x597 = nm->mkBoundVar("x597", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount598 = nm->mkBoundVar("amount598", nm->integerType());
Node sz599 = nm->mkBoundVar("sz599", nm->integerType());
Node x600 = nm->mkBoundVar("x600", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount601 = nm->mkBoundVar("amount601", nm->integerType());
Node sz602 = nm->mkBoundVar("sz602", nm->integerType());
Node x603 = nm->mkBoundVar("x603", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y604 = nm->mkBoundVar("y604", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z605 = nm->mkBoundVar("z605", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys606 = nm->mkBoundVar("ys606", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys606);
Node t748 = nm->mkBoundVar("t748", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x607 = nm->mkBoundVar("x607", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y608 = nm->mkBoundVar("y608", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z609 = nm->mkBoundVar("z609", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys610 = nm->mkBoundVar("ys610", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys610);
Node t749 = nm->mkBoundVar("t749", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x611 = nm->mkBoundVar("x611", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y612 = nm->mkBoundVar("y612", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z613 = nm->mkBoundVar("z613", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys614 = nm->mkBoundVar("ys614", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys614);
Node t750 = nm->mkBoundVar("t750", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x615 = nm->mkBoundVar("x615", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x616 = nm->mkBoundVar("x616", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x617 = nm->mkBoundVar("x617", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n618 = nm->mkBoundVar("n618", nm->integerType());
Node x619 = nm->mkBoundVar("x619", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y620 = nm->mkBoundVar("y620", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x621 = nm->mkBoundVar("x621", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y622 = nm->mkBoundVar("y622", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x623 = nm->mkBoundVar("x623", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x624 = nm->mkBoundVar("x624", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y625 = nm->mkBoundVar("y625", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x626 = nm->mkBoundVar("x626", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n627 = nm->mkBoundVar("n627", nm->integerType());
Node x628 = nm->mkBoundVar("x628", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x629 = nm->mkBoundVar("x629", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x630 = nm->mkBoundVar("x630", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y631 = nm->mkBoundVar("y631", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x632 = nm->mkBoundVar("x632", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x633 = nm->mkBoundVar("x633", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n634 = nm->mkBoundVar("n634", nm->integerType());
Node x635 = nm->mkBoundVar("x635", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n636 = nm->mkBoundVar("n636", nm->integerType());
Node x637 = nm->mkBoundVar("x637", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x638 = nm->mkBoundVar("x638", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x639 = nm->mkBoundVar("x639", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x640 = nm->mkBoundVar("x640", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n641 = nm->mkBoundVar("n641", nm->integerType());
Node x642 = nm->mkBoundVar("x642", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n643 = nm->mkBoundVar("n643", nm->integerType());
Node x644 = nm->mkBoundVar("x644", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x645 = nm->mkBoundVar("x645", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y646 = nm->mkBoundVar("y646", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x647 = nm->mkBoundVar("x647", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y648 = nm->mkBoundVar("y648", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x649 = nm->mkBoundVar("x649", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y650 = nm->mkBoundVar("y650", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x651 = nm->mkBoundVar("x651", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y652 = nm->mkBoundVar("y652", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs653 = nm->mkBoundVar("xs653", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs653);
Node ys654 = nm->mkBoundVar("ys654", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys654);
Node z655 = nm->mkBoundVar("z655", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size656 = nm->mkBoundVar("size656", nm->integerType());
Node n657 = nm->mkBoundVar("n657", nm->integerType());
Node xs658 = nm->mkBoundVar("xs658", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs658);
Node ys659 = nm->mkBoundVar("ys659", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys659);
Node z660 = nm->mkBoundVar("z660", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size661 = nm->mkBoundVar("size661", nm->integerType());
Node n662 = nm->mkBoundVar("n662", nm->integerType());
Node z663 = nm->mkBoundVar("z663", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size664 = nm->mkBoundVar("size664", nm->integerType());
Node n665 = nm->mkBoundVar("n665", nm->integerType());
Node high666 = nm->mkBoundVar("high666", nm->integerType());
Node low667 = nm->mkBoundVar("low667", nm->integerType());
Node x1i668 = nm->mkBoundVar("x1i668", nm->integerType());
Node x1in669 = nm->mkBoundVar("x1in669", nm->integerType());
Node x2670 = nm->mkBoundVar("x2670", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y1i671 = nm->mkBoundVar("y1i671", nm->integerType());
Node y1in672 = nm->mkBoundVar("y1in672", nm->integerType());
Node y2673 = nm->mkBoundVar("y2673", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x674 = nm->mkBoundVar("x674", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v675 = nm->mkBoundVar("v675", nm->integerType());
Node n676 = nm->mkBoundVar("n676", nm->integerType());
Node x677 = nm->mkBoundVar("x677", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n678 = nm->mkBoundVar("n678", nm->integerType());
Node x679 = nm->mkBoundVar("x679", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n680 = nm->mkBoundVar("n680", nm->integerType());
Node x681 = nm->mkBoundVar("x681", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v682 = nm->mkBoundVar("v682", nm->integerType());
Node n683 = nm->mkBoundVar("n683", nm->integerType());
Node x684 = nm->mkBoundVar("x684", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n685 = nm->mkBoundVar("n685", nm->integerType());
Node x686 = nm->mkBoundVar("x686", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a687 = nm->mkBoundVar("a687", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n688 = nm->mkBoundVar("n688", nm->integerType());
Node a689 = nm->mkBoundVar("a689", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n690 = nm->mkBoundVar("n690", nm->integerType());
Node a691 = nm->mkBoundVar("a691", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n692 = nm->mkBoundVar("n692", nm->integerType());
Node y693 = nm->mkBoundVar("y693", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x694 = nm->mkBoundVar("x694", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x695 = nm->mkBoundVar("x695", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n696 = nm->mkBoundVar("n696", nm->integerType());
Node x697 = nm->mkBoundVar("x697", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n698 = nm->mkBoundVar("n698", nm->integerType());
Node x699 = nm->mkBoundVar("x699", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i700 = nm->mkBoundVar("i700", nm->integerType());
Node j701 = nm->mkBoundVar("j701", nm->integerType());
Node x702 = nm->mkBoundVar("x702", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i703 = nm->mkBoundVar("i703", nm->integerType());
Node j704 = nm->mkBoundVar("j704", nm->integerType());
Node x705 = nm->mkBoundVar("x705", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i706 = nm->mkBoundVar("i706", nm->integerType());
Node n0707 = nm->mkBoundVar("n0707", nm->integerType());
Node x708 = nm->mkBoundVar("x708", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m709 = nm->mkBoundVar("m709", nm->integerType());
Node c710 = nm->mkBoundVar("c710", nm->integerType());
Node nm711 = nm->mkBoundVar("nm711", nm->integerType());
Node x712 = nm->mkBoundVar("x712", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m713 = nm->mkBoundVar("m713", nm->integerType());
Node c714 = nm->mkBoundVar("c714", nm->integerType());
Node nm715 = nm->mkBoundVar("nm715", nm->integerType());
Node x716 = nm->mkBoundVar("x716", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m717 = nm->mkBoundVar("m717", nm->integerType());
Node c718 = nm->mkBoundVar("c718", nm->integerType());
Node nm719 = nm->mkBoundVar("nm719", nm->integerType());
Node x720 = nm->mkBoundVar("x720", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m721 = nm->mkBoundVar("m721", nm->integerType());
Node c722 = nm->mkBoundVar("c722", nm->integerType());
Node nm723 = nm->mkBoundVar("nm723", nm->integerType());
Node x724 = nm->mkBoundVar("x724", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m725 = nm->mkBoundVar("m725", nm->integerType());
Node c726 = nm->mkBoundVar("c726", nm->integerType());
Node nm727 = nm->mkBoundVar("nm727", nm->integerType());
Node x728 = nm->mkBoundVar("x728", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m729 = nm->mkBoundVar("m729", nm->integerType());
Node c730 = nm->mkBoundVar("c730", nm->integerType());
Node nm731 = nm->mkBoundVar("nm731", nm->integerType());
Node x732 = nm->mkBoundVar("x732", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m733 = nm->mkBoundVar("m733", nm->integerType());
Node c734 = nm->mkBoundVar("c734", nm->integerType());
Node nm735 = nm->mkBoundVar("nm735", nm->integerType());
Node x736 = nm->mkBoundVar("x736", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m737 = nm->mkBoundVar("m737", nm->integerType());
Node c738 = nm->mkBoundVar("c738", nm->integerType());
Node nm739 = nm->mkBoundVar("nm739", nm->integerType());
Node x740 = nm->mkBoundVar("x740", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m741 = nm->mkBoundVar("m741", nm->integerType());
Node c742 = nm->mkBoundVar("c742", nm->integerType());
Node nm743 = nm->mkBoundVar("nm743", nm->integerType());
Node x744 = nm->mkBoundVar("x744", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m745 = nm->mkBoundVar("m745", nm->integerType());
Node c746 = nm->mkBoundVar("c746", nm->integerType());
Node nm747 = nm->mkBoundVar("nm747", nm->integerType());

  // Definitions
Node e751 = nm->mkConstRealOrInt(Rational(1));
Node e752 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x744 }),nm->mkConstRealOrInt(Rational(1)) });
Node e753 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c746,nm747 });
Node e754 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x744 }),nm->mkConstRealOrInt(Rational(1)) }),nm747 });
Node e755 = nm->mkConstRealOrInt(Rational(0));
Node e756 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c742,nm743 });
Node e757 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x740 }),nm->mkConstRealOrInt(Rational(1)) });
Node e758 = nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm743 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x740 }),nm->mkConstRealOrInt(Rational(1)) }),nm743 }) });
Node e759 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x736 }),nm->mkConstRealOrInt(Rational(1)) });
Node e760 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c738,nm739 });
Node e761 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x736 }),nm->mkConstRealOrInt(Rational(1)) }),nm739 });
Node e762 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c734,nm735 });
Node e763 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x732 }),nm->mkConstRealOrInt(Rational(1)) });
Node e764 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x732 }),nm->mkConstRealOrInt(Rational(1)) }),nm735 });
Node e765 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c730,nm731 });
Node e766 = nm->mkNode(Kind::BITVECTOR_SIZE, { x728 });
Node e767 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c726,nm727 });
Node e768 = nm->mkNode(Kind::BITVECTOR_SIZE, { x724 });
Node e769 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c722,nm723 });
Node e770 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x720 }),nm->mkConstRealOrInt(Rational(1)) });
Node e771 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c718,nm719 });
Node e772 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x716 }),nm->mkConstRealOrInt(Rational(1)) });
Node e773 = nm->mkConst(true);
Node e774 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c714,nm715 });
Node e775 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x712 }),nm->mkConstRealOrInt(Rational(1)) });
Node e776 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::ADD, { m713,nm->mkConstRealOrInt(Rational(1)) }) });
Node e777 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm715,nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x712 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c714,nm715 }) });
Node e778 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c710,nm711 });
Node e779 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x708 }),nm->mkConstRealOrInt(Rational(1)) });
Node e780 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::ADD, { m709,nm->mkConstRealOrInt(Rational(1)) }) });
Node e781 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm711,nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x708 }),nm->mkConstRealOrInt(Rational(1)) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c710,nm711 }) });
Node e782 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(1)),nm->mkConstRealOrInt(Rational(1)) });
Node e783 = nm->mkNode(Kind::SUB, { n698,nm->mkConstRealOrInt(Rational(1)) });
Node e784 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n692 });
Node e785 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n690 });
Node e786 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n688 });
Node e787 = nm->mkNode(Kind::INTS_LOG2, { v682 });
Node e788 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n678 });
Node e789 = nm->mkNode(Kind::INTS_LOG2, { v675 });
Node e790 = nm->mkNode(Kind::ADD, { x1in669,nm->mkNode(Kind::BITVECTOR_SIZE, { x2670 }) });
Node e791 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::NEG, { n665 }) });
Node e792 = nm->mkNode(Kind::NEG, { n665 });
Node e793 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::NEG, { n662 }) });
Node e794 = nm->mkNode(Kind::NEG, { n662 });
Node e795 = nm->mkNode(Kind::INTS_LOG2, { n657 });
Node e796 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n641 });
Node e797 = nm->mkConst(false);
Node e798 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n634 });
Node e799 = nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::BITVECTOR_SIZE, { y622 }) }) });
Node e800 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),n618 });
Node e801 = nm->mkNode(Kind::BITVECTOR_SIZE, { y612 });
Node e802 = nm->mkNode(Kind::BITVECTOR_SIZE, { y608 });
Node e803 = nm->mkNode(Kind::BITVECTOR_SIZE, { y604 });
Node e804 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x600 }),nm->mkConstRealOrInt(Rational(1)) });
Node e805 = nm->mkNode(Kind::BITVECTOR_SIZE, { x600 });
Node e806 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x597 }),nm->mkConstRealOrInt(Rational(1)) });
Node e807 = nm->mkNode(Kind::BITVECTOR_SIZE, { x597 });
Node e808 = nm->mkNode(Kind::BITVECTOR_SIZE, { x589 });
Node e809 = nm->mkNode(Kind::BITVECTOR_SIZE, { x584 });
Node e810 = nm->mkNode(Kind::BITVECTOR_SIZE, { x581 });
Node e811 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkConstRealOrInt(Rational(1)) });

  // Rules

        {
            // from rewrites-bv-rewrites-simplification.cpp
            db.addRule(ProofRewriteRule::BV_ITE_EQUAL_CHILDREN, { c546, x547 }, nm->mkNode(Kind::BITVECTOR_ITE, { c546,x547,x547 }), x547, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_1, { c548 }, nm->mkNode(Kind::BITVECTOR_ITE, { c548,e811,e782 }), nm->mkNode(Kind::BITVECTOR_NOT, { c548 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_2, { c549 }, nm->mkNode(Kind::BITVECTOR_ITE, { c549,e782,e811 }), c549, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_1, { c0550, t0551, e0552, e1553 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0550,nm->mkNode(Kind::BITVECTOR_ITE, { c0550,t0551,e0552 }),e1553 }), nm->mkNode(Kind::BITVECTOR_ITE, { c0550,t0551,e1553 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_2, { c0554, t0555, t1556, e1557 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0554,t0555,nm->mkNode(Kind::BITVECTOR_ITE, { c0554,t1556,e1557 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0554,t0555,e1557 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_3, { c0558, t0559, e0560, t1561, e1562 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0558,nm->mkNode(Kind::BITVECTOR_ITE, { c0558,t0559,e0560 }),nm->mkNode(Kind::BITVECTOR_ITE, { c0558,t1561,e1562 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0558,t0559,e1562 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_IF, { c0563, c1564, t1565, e1566 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0563,nm->mkNode(Kind::BITVECTOR_ITE, { c1564,t1565,e1566 }),t1565 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0563,nm->mkNode(Kind::BITVECTOR_NOT, { c1564 }) }),e1566,t1565 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_IF, { c0567, c1568, t1569, e1570 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0567,nm->mkNode(Kind::BITVECTOR_ITE, { c1568,t1569,e1570 }),e1570 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0567,c1568 }),t1569,e1570 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_ELSE, { c0571, c1572, t0573, e1574 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0571,t0573,nm->mkNode(Kind::BITVECTOR_ITE, { c1572,t0573,e1574 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_NOR, { c0571,c1572 }),e1574,t0573 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_ELSE, { c0575, c1576, t1577, t0578 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0575,t0578,nm->mkNode(Kind::BITVECTOR_ITE, { c1576,t1577,t0578 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::BITVECTOR_NOT, { c0575 }),c1576 }),t1577,t0578 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_0, { x579, sz580 }, nm->mkNode(Kind::BITVECTOR_SHL, { x579,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,sz580 }) }), x579, e773, Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_1, { x581, amount582, sz583 }, nm->mkNode(Kind::BITVECTOR_SHL, { x581,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount582,sz583 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e810,nm->mkNode(Kind::ADD, { e751,amount582 }) }),e755,x581 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,amount582 }) }), nm->mkNode(Kind::LT, { amount582,e810 }), Node::null());
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_2, { x584, amount585, sz586 }, nm->mkNode(Kind::BITVECTOR_SHL, { x584,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount585,sz586 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,e809 }), nm->mkNode(Kind::GEQ, { amount585,e809 }), Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_0, { x587, sz588 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x587,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,sz588 }) }), x587, e773, Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_1, { x589, amount590, sz591 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x589,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount590,sz591 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,amount590 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e808,e751 }),amount590,x589 }) }), nm->mkNode(Kind::LT, { amount590,e808 }), Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_2, { x592, amount593, sz594 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x592,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount593,sz594 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,sz594 }), nm->mkNode(Kind::GEQ, { amount593,nm->mkNode(Kind::BITVECTOR_SIZE, { x592 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_0, { x595, sz596 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x595,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,sz596 }) }), x595, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_1, { x597, amount598, sz599 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x597,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount598,sz599 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),amount598,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e806,e806,x597 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e806,amount598,x597 }) }), nm->mkNode(Kind::LT, { amount598,e807 }), Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_2, { x600, amount601, sz602 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x600,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount601,sz602 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),e805,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e804,e804,x600 }) }), nm->mkNode(Kind::GEQ, { amount601,e805 }), Node::null());
db.addRule(ProofRewriteRule::BV_AND_CONCAT_PULLUP, { x603, y604, z605, ys606 }, nm->mkNode(Kind::BITVECTOR_AND, { x603,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys606,z605,y604 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x603 }),e751 }),e803,x603 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys606,z605 }) }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e803,e751 }),e755,x603 }),y604 }) }), e773, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t748 }),t748 }));
db.addRule(ProofRewriteRule::BV_OR_CONCAT_PULLUP, { x607, y608, z609, ys610 }, nm->mkNode(Kind::BITVECTOR_OR, { x607,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys610,z609,y608 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x607 }),e751 }),e802,x607 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys610,z609 }) }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e802,e751 }),e755,x607 }),y608 }) }), e773, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t749 }),t749 }));
db.addRule(ProofRewriteRule::BV_XOR_CONCAT_PULLUP, { x611, y612, z613, ys614 }, nm->mkNode(Kind::BITVECTOR_XOR, { x611,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys614,z613,y612 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x611 }),e751 }),e801,x611 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys614,z613 }) }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e801,e751 }),e755,x611 }),y612 }) }), e773, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t750 }),t750 }));
db.addRule(ProofRewriteRule::BV_BITWISE_IDEMP_1, { x615 }, nm->mkNode(Kind::BITVECTOR_AND, { x615,x615 }), x615, e773, Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_IDEMP_2, { x616 }, nm->mkNode(Kind::BITVECTOR_OR, { x616,x616 }), x616, e773, Node::null());
db.addRule(ProofRewriteRule::BV_AND_ZERO, { x617, n618 }, nm->mkNode(Kind::BITVECTOR_AND, { x617,e800 }), e800, e773, Node::null());
db.addRule(ProofRewriteRule::BV_AND_ONE, { x619, y620 }, nm->mkNode(Kind::BITVECTOR_AND, { x619,y620 }), x619, nm->mkNode(Kind::EQUAL, { y620,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { y620 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_ONE, { x621, y622 }, nm->mkNode(Kind::BITVECTOR_OR, { x621,y622 }), e799, nm->mkNode(Kind::EQUAL, { y622,e799 }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_DUPLICATE, { x623 }, nm->mkNode(Kind::BITVECTOR_XOR, { x623,x623 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { x623 }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_XOR_ONES, { x624, y625 }, nm->mkNode(Kind::BITVECTOR_XOR, { x624,y625 }), nm->mkNode(Kind::BITVECTOR_NOT, { x624 }), nm->mkNode(Kind::EQUAL, { y625,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { y625 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_XOR_ZERO, { x626, n627 }, nm->mkNode(Kind::BITVECTOR_XOR, { x626,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n627 }) }), x626, e773, Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_NOT_AND, { x628 }, nm->mkNode(Kind::BITVECTOR_AND, { x628,nm->mkNode(Kind::BITVECTOR_NOT, { x628 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { x628 }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_BITWISE_NOT_OR, { x629 }, nm->mkNode(Kind::BITVECTOR_OR, { x629,nm->mkNode(Kind::BITVECTOR_NOT, { x629 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { x629 }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_XOR_NOT, { x630, y631 }, nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x630 }),nm->mkNode(Kind::BITVECTOR_NOT, { y631 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { x630,y631 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_IDEMP, { x632 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_NOT, { x632 }) }), x632, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ZERO_1, { x633, n634 }, nm->mkNode(Kind::BITVECTOR_ULT, { e798,x633 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x633,e798 }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ZERO_2, { x635, n636 }, nm->mkNode(Kind::BITVECTOR_ULT, { x635,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n636 }) }), e797, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_SELF, { x637 }, nm->mkNode(Kind::BITVECTOR_ULT, { x637,x637 }), e797, e773, Node::null());
db.addRule(ProofRewriteRule::BV_LT_SELF, { x638 }, nm->mkNode(Kind::BITVECTOR_SLT, { x638,x638 }), e797, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_SELF, { x639 }, nm->mkNode(Kind::BITVECTOR_ULE, { x639,x639 }), e773, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_ZERO, { x640, n641 }, nm->mkNode(Kind::BITVECTOR_ULE, { x640,e796 }), nm->mkNode(Kind::EQUAL, { x640,e796 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_ULE, { x642, n643 }, nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n643 }),x642 }), e773, e773, Node::null());
db.addRule(ProofRewriteRule::BV_SLE_SELF, { x644 }, nm->mkNode(Kind::BITVECTOR_SLE, { x644,x644 }), e773, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULE_MAX, { x645, y646 }, nm->mkNode(Kind::BITVECTOR_ULE, { x645,y646 }), e773, nm->mkNode(Kind::EQUAL, { y646,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { y646 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_NOT_ULT, { x647, y648 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { x647,y648 }) }), nm->mkNode(Kind::BITVECTOR_ULE, { y648,x647 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_ULE, { x649, y650 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULE, { x649,y650 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { y650,x649 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_SLE, { x651, y652 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_SLE, { x651,y652 }) }), nm->mkNode(Kind::BITVECTOR_SLT, { y652,x651 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_1, { xs653, ys654, z655, size656, n657 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs653,z655,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n657,size656 }),ys654 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size656,e795 }),e751 }),e755,nm->mkNode(Kind::BITVECTOR_MULT, { xs653,z655,ys654 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,e795 }) }), nm->mkNode(Kind::INTS_ISPOW2, { n657 }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_2, { xs658, ys659, z660, size661, n662 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs658,z660,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n662,size661 }),ys659 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size661,e793 }),e751 }),e755,nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_MULT, { xs658,z660,ys659 }) }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,e793 }) }), nm->mkNode(Kind::INTS_ISPOW2, { e794 }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_POW2_2B, { z663, size664, n665 }, nm->mkNode(Kind::BITVECTOR_MULT, { z663,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n665,size664 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size664,e791 }),e751 }),e755,nm->mkNode(Kind::BITVECTOR_NEG, { z663 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,e791 }) }), nm->mkNode(Kind::INTS_ISPOW2, { e792 }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_MULT_LEADING_BIT, { high666, low667, x1i668, x1in669, x2670, y1i671, y1in672, y2673 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high666,low667,nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { x1i668,x1in669 }),x2670 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { y1i671,y1in672 }),y2673 }) }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::ADD, { e751,nm->mkNode(Kind::SUB, { high666,low667 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { e790,nm->mkConstRealOrInt(Rational(64)) }),nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::MULT, { nm->mkConstRealOrInt(Rational(2)),e790 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x1i668,e755 }),x1in669,nm->mkNode(Kind::SUB, { x1in669,nm->mkNode(Kind::ADD, { e751,nm->mkNode(Kind::INTS_LOG2, { x1i668 }) }) }) }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { y1i671,e755 }),y1in672,nm->mkNode(Kind::SUB, { y1in672,nm->mkNode(Kind::ADD, { e751,nm->mkNode(Kind::INTS_LOG2, { y1i671 }) }) }) }) }) }),low667 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_POW2_NOT_ONE, { x674, v675, n676 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x674,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v675,n676 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,e789 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { n676,e751 }),e789,x674 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v675 }),nm->mkNode(Kind::GT, { v675,e751 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_ZERO, { x677, n678 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x677,e788 }), nm->mkNode(Kind::BITVECTOR_NOT, { e788 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_UDIV_ONE, { x679, n680 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x679,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,n680 }) }), x679, e773, Node::null());
db.addRule(ProofRewriteRule::BV_UREM_POW2_NOT_ONE, { x681, v682, n683 }, nm->mkNode(Kind::BITVECTOR_UREM, { x681,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v682,n683 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::SUB, { n683,e787 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e787,e751 }),e755,x681 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v682 }),nm->mkNode(Kind::GT, { v682,e751 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_UREM_ONE, { x684, n685 }, nm->mkNode(Kind::BITVECTOR_UREM, { x684,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,n685 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n685 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_UREM_SELF, { x686 }, nm->mkNode(Kind::BITVECTOR_UREM, { x686,x686 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { x686 }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_SHL_ZERO, { a687, n688 }, nm->mkNode(Kind::BITVECTOR_SHL, { e786,a687 }), e786, e773, Node::null());
db.addRule(ProofRewriteRule::BV_LSHR_ZERO, { a689, n690 }, nm->mkNode(Kind::BITVECTOR_LSHR, { e785,a689 }), e785, e773, Node::null());
db.addRule(ProofRewriteRule::BV_ASHR_ZERO, { a691, n692 }, nm->mkNode(Kind::BITVECTOR_ASHR, { e784,a691 }), e784, e773, Node::null());
db.addRule(ProofRewriteRule::BV_UGT_UREM, { y693, x694 }, nm->mkNode(Kind::BITVECTOR_UGT, { nm->mkNode(Kind::BITVECTOR_UREM, { y693,x694 }),x694 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x694,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { x694 }) }) }),nm->mkNode(Kind::BITVECTOR_UGT, { y693,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm->mkNode(Kind::BITVECTOR_SIZE, { y693 }) }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ONE, { x695, n696 }, nm->mkNode(Kind::BITVECTOR_ULT, { x695,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,n696 }) }), nm->mkNode(Kind::EQUAL, { x695,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n696 }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_SLT_ZERO, { x697, n698 }, nm->mkNode(Kind::BITVECTOR_SLT, { x697,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,n698 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e783,e783,x697 }),e782 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_1, { x699, i700, j701 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i700,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),j701,x699 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),nm->mkNode(Kind::ADD, { i700,j701 }),x699 }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_2, { x702, i703, j704 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i703,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),j704,x702 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),nm->mkNode(Kind::ADD, { i703,j704 }),x702 }), nm->mkNode(Kind::GT, { j704,e751 }), Node::null());
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_3, { x705, i706, n0707 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i706,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n0707,x705 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i706,x705 }), nm->mkNode(Kind::EQUAL, { n0707,e755 }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_1, { x708, m709, c710, nm711 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m709,x708 }),e778 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e781,e780 }),nm->mkNode(Kind::EQUAL, { e781,nm->mkNode(Kind::BITVECTOR_NOT, { e780 }) }) }),nm->mkNode(Kind::EQUAL, { x708,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e779,e755,e778 }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_2, { x712, m713, c714, nm715 }, nm->mkNode(Kind::EQUAL, { e774,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m713,x712 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e777,e776 }),nm->mkNode(Kind::EQUAL, { e777,nm->mkNode(Kind::BITVECTOR_NOT, { e776 }) }) }),nm->mkNode(Kind::EQUAL, { x712,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e775,e755,e774 }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_1, { x716, m717, c718, nm719 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m717,x716 }),e771 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm719,e751 }),e772,e771 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,m717 }) }),nm->mkNode(Kind::EQUAL, { x716,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e772,e755,e771 }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_2, { x720, m721, c722, nm723 }, nm->mkNode(Kind::EQUAL, { e769,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m721,x720 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm723,e751 }),e770,e769 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,m721 }) }),nm->mkNode(Kind::EQUAL, { x720,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e770,e755,e769 }) }) }), e773, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ULT_CONST_1, { x724, m725, c726, nm727 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m725,x724 }),e767 }), nm->mkNode(Kind::BITVECTOR_ULT, { x724,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e768,e751 }),e755,e767 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm727,e751 }),e768,e767 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,m725 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ULT_CONST_2, { x728, m729, c730, nm731 }, nm->mkNode(Kind::BITVECTOR_ULT, { e765,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m729,x728 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e766,e751 }),e755,e765 }),x728 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { nm731,e751 }),e766,e765 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,m729 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_1, { x732, m733, c734, nm735 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m733,x732 }),e762 }), nm->mkNode(Kind::BITVECTOR_ULT, { x732,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e763,e755,e762 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULE, { e762,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,nm735 }),e764 }) }),nm->mkNode(Kind::BITVECTOR_UGE, { e762,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm735 }) }),e764 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_2, { x736, m737, c738, nm739 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m737,x736 }),e760 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e759,e759,x736 }),e811 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,nm739 }),e761 }),e760 }),nm->mkNode(Kind::BITVECTOR_ULE, { e760,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm739 }) }),e761 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_3, { x740, m741, c742, nm743 }, nm->mkNode(Kind::BITVECTOR_ULT, { e756,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m741,x740 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e757,e755,e756 }),x740 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULT, { e756,e758 }),nm->mkNode(Kind::BITVECTOR_UGE, { e756,nm->mkNode(Kind::BITVECTOR_NOT, { e758 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_4, { x744, m745, c746, nm747 }, nm->mkNode(Kind::BITVECTOR_ULT, { e753,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m745,x744 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e752,e752,x744 }),e782 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e755,nm747 }) }),e754 }) }),e753 }),nm->mkNode(Kind::BITVECTOR_ULE, { e753,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e751,nm747 }),e754 }) }) }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
