/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_sets_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x812 = nm->mkBoundVar("x812", nm->mkAbstractType(Kind::SET_TYPE));
Node y813 = nm->mkBoundVar("y813", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x814 = nm->mkBoundVar("x814", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y815 = nm->mkBoundVar("y815", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x816 = nm->mkBoundVar("x816", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y817 = nm->mkBoundVar("y817", nm->mkAbstractType(Kind::SET_TYPE));
Node x818 = nm->mkBoundVar("x818", nm->mkAbstractType(Kind::SET_TYPE));
Node y819 = nm->mkBoundVar("y819", nm->mkAbstractType(Kind::SET_TYPE));
Node x820 = nm->mkBoundVar("x820", nm->mkAbstractType(Kind::SET_TYPE));
Node y821 = nm->mkBoundVar("y821", nm->mkAbstractType(Kind::SET_TYPE));
Node x822 = nm->mkBoundVar("x822", nm->mkAbstractType(Kind::SET_TYPE));
Node y823 = nm->mkBoundVar("y823", nm->mkAbstractType(Kind::SET_TYPE));
Node x824 = nm->mkBoundVar("x824", nm->mkAbstractType(Kind::SET_TYPE));
Node y825 = nm->mkBoundVar("y825", nm->mkAbstractType(Kind::SET_TYPE));
Node x826 = nm->mkBoundVar("x826", nm->mkAbstractType(Kind::SET_TYPE));
Node y827 = nm->mkBoundVar("y827", nm->mkAbstractType(Kind::SET_TYPE));
Node x828 = nm->mkBoundVar("x828", nm->mkAbstractType(Kind::SET_TYPE));
Node y829 = nm->mkBoundVar("y829", nm->mkAbstractType(Kind::SET_TYPE));
Node x830 = nm->mkBoundVar("x830", nm->mkAbstractType(Kind::SET_TYPE));
Node y831 = nm->mkBoundVar("y831", nm->mkAbstractType(Kind::SET_TYPE));
Node x832 = nm->mkBoundVar("x832", nm->mkAbstractType(Kind::SET_TYPE));
Node y833 = nm->mkBoundVar("y833", nm->mkAbstractType(Kind::SET_TYPE));
Node x834 = nm->mkBoundVar("x834", nm->mkAbstractType(Kind::SET_TYPE));
Node y835 = nm->mkBoundVar("y835", nm->mkAbstractType(Kind::SET_TYPE));
Node x836 = nm->mkBoundVar("x836", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y837 = nm->mkBoundVar("y837", nm->mkAbstractType(Kind::SET_TYPE));
Node z838 = nm->mkBoundVar("z838", nm->mkAbstractType(Kind::SET_TYPE));
Node x839 = nm->mkBoundVar("x839", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y840 = nm->mkBoundVar("y840", nm->mkAbstractType(Kind::SET_TYPE));
Node z841 = nm->mkBoundVar("z841", nm->mkAbstractType(Kind::SET_TYPE));
Node x842 = nm->mkBoundVar("x842", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y843 = nm->mkBoundVar("y843", nm->mkAbstractType(Kind::SET_TYPE));
Node z844 = nm->mkBoundVar("z844", nm->mkAbstractType(Kind::SET_TYPE));
Node x845 = nm->mkBoundVar("x845", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x846 = nm->mkBoundVar("x846", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s847 = nm->mkBoundVar("s847", nm->mkAbstractType(Kind::SET_TYPE));
Node t848 = nm->mkBoundVar("t848", nm->mkAbstractType(Kind::SET_TYPE));
Node s849 = nm->mkBoundVar("s849", nm->mkAbstractType(Kind::SET_TYPE));
Node t850 = nm->mkBoundVar("t850", nm->mkAbstractType(Kind::SET_TYPE));
Node x851 = nm->mkBoundVar("x851", nm->mkAbstractType(Kind::SET_TYPE));

  // Definitions
Node e852 = nm->mkConst(true);
Node e853 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-sets-rewrites.cpp
            db.addRule(ProofRewriteRule::SETS_EQ_SINGLETON_EMP, { x812, y813 }, nm->mkNode(Kind::EQUAL, { x812,nm->mkNode(Kind::SET_SINGLETON, { y813 }) }), e853, nm->mkNode(Kind::SET_IS_EMPTY, { x812 }), Node::null());
db.addRule(ProofRewriteRule::SETS_MEMBER_SINGLETON, { x814, y815 }, nm->mkNode(Kind::SET_MEMBER, { x814,nm->mkNode(Kind::SET_SINGLETON, { y815 }) }), nm->mkNode(Kind::EQUAL, { x814,y815 }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_MEMBER_EMP, { x816, y817 }, nm->mkNode(Kind::SET_MEMBER, { x816,y817 }), e853, nm->mkNode(Kind::SET_IS_EMPTY, { y817 }), Node::null());
db.addRule(ProofRewriteRule::SETS_SUBSET_ELIM, { x818, y819 }, nm->mkNode(Kind::SET_SUBSET, { x818,y819 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SET_UNION, { x818,y819 }),y819 }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_COMM, { x820, y821 }, nm->mkNode(Kind::SET_UNION, { x820,y821 }), nm->mkNode(Kind::SET_UNION, { y821,x820 }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_COMM, { x822, y823 }, nm->mkNode(Kind::SET_INTER, { x822,y823 }), nm->mkNode(Kind::SET_INTER, { y823,x822 }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_EMP1, { x824, y825 }, nm->mkNode(Kind::SET_INTER, { x824,y825 }), x824, nm->mkNode(Kind::SET_IS_EMPTY, { x824 }), Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_EMP2, { x826, y827 }, nm->mkNode(Kind::SET_INTER, { x826,y827 }), y827, nm->mkNode(Kind::SET_IS_EMPTY, { y827 }), Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_EMP1, { x828, y829 }, nm->mkNode(Kind::SET_MINUS, { x828,y829 }), x828, nm->mkNode(Kind::SET_IS_EMPTY, { x828 }), Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_EMP2, { x830, y831 }, nm->mkNode(Kind::SET_MINUS, { x830,y831 }), x830, nm->mkNode(Kind::SET_IS_EMPTY, { y831 }), Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_EMP1, { x832, y833 }, nm->mkNode(Kind::SET_UNION, { x832,y833 }), y833, nm->mkNode(Kind::SET_IS_EMPTY, { x832 }), Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_EMP2, { x834, y835 }, nm->mkNode(Kind::SET_UNION, { x834,y835 }), x834, nm->mkNode(Kind::SET_IS_EMPTY, { y835 }), Node::null());
db.addRule(ProofRewriteRule::SETS_INTER_MEMBER, { x836, y837, z838 }, nm->mkNode(Kind::SET_MEMBER, { x836,nm->mkNode(Kind::SET_INTER, { y837,z838 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x836,y837 }),nm->mkNode(Kind::SET_MEMBER, { x836,z838 }) }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_MINUS_MEMBER, { x839, y840, z841 }, nm->mkNode(Kind::SET_MEMBER, { x839,nm->mkNode(Kind::SET_MINUS, { y840,z841 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x839,y840 }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::SET_MEMBER, { x839,z841 }) }) }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_UNION_MEMBER, { x842, y843, z844 }, nm->mkNode(Kind::SET_MEMBER, { x842,nm->mkNode(Kind::SET_UNION, { y843,z844 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::SET_MEMBER, { x842,y843 }),nm->mkNode(Kind::SET_MEMBER, { x842,z844 }) }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_CHOOSE_SINGLETON, { x845 }, nm->mkNode(Kind::SET_CHOOSE, { nm->mkNode(Kind::SET_SINGLETON, { x845 }) }), x845, e852, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_SINGLETON, { x846 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_SINGLETON, { x846 }) }), nm->mkConstRealOrInt(Rational(1)), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_UNION, { s847, t848 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_UNION, { s847,t848 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::SET_CARD, { s847 }),nm->mkNode(Kind::SET_CARD, { t848 }) }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s847,t848 }) }) }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_MINUS, { s849, t850 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_MINUS, { s849,t850 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SET_CARD, { s849 }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s849,t850 }) }) }), e852, Node::null());
db.addRule(ProofRewriteRule::SETS_CARD_EMP, { x851 }, nm->mkNode(Kind::SET_CARD, { x851 }), nm->mkConstRealOrInt(Rational(0)), nm->mkNode(Kind::SET_IS_EMPTY, { x851 }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
